import cv2
from paho.mqtt import client
import numpy as np
import random
import math

zone = 1


def draw_zones(image):
    cv2.line(image, (0, 240), (639, 240), (0, 255, 0), 5)
    cv2.line(image, (320, 0), (320, 479), (0, 255, 0), 5)
    cv2.putText(image, '1', (320, 50), cv2.FONT_HERSHEY_SIMPLEX, 2, (0, 0, 255), 3)
    cv2.putText(image, '2', (320, 290), cv2.FONT_HERSHEY_SIMPLEX, 2, (0, 0, 255), 3)
    cv2.putText(image, '3', (0, 298), cv2.FONT_HERSHEY_SIMPLEX, 2, (0, 0, 255), 3)
    cv2.putText(image, '4', (0, 50), cv2.FONT_HERSHEY_SIMPLEX, 2, (0, 0, 255), 3)


def detect_zone(x_center, y_center, image):
    zone = 'zone none '
    if x_center > 320:
        if y_center < 240:
            zone = '1'
        else:
            zone = '2'
    else:
        if y_center < 240:
            zone = '4'
        else:
            zone = '3'

    cv2.putText(image, zone, (int(x_center), int(y_center)), cv2.FONT_HERSHEY_SIMPLEX, 2, (255, 0, 0), 3)
    return zone


client_id = f'python-mqtt-{random.randint(0, 1000)}'
my_client = client.Client(client.CallbackAPIVersion.VERSION1, client_id)

hostname = '95.163.230.191'
user_name = "maker"
password = "LABmaker123"
port = 1883

topik = 'aqua'
my_client.username_pw_set(user_name, password)
my_client.connect(hostname, port)
my_client.publish(topik, 'ON')

cap = cv2.VideoCapture(1)

hsv_min_boat = np.array((7, 179, 224), np.uint8)
hsv_max_boat = np.array((255, 255, 255), np.uint8)
hsv_min_oil = np.array((0, 0, 0), np.uint8)
hsv_max_oil = np.array((0, 0, 0), np.uint8)

x_boat = 0
y_boat = 0
x_oil = 0
y_oil = 0
dist = 0
i = 0
color_yellow = (0, 255, 255)

while True:
    flag, img = cap.read()

    hsv = cv2.cvtColor(img, cv2.COLOR_BGR2HSV)

    thresh_oil = cv2.inRange(hsv, hsv_min_oil, hsv_max_oil)
    thresh_boat = cv2.inRange(hsv, hsv_min_boat, hsv_max_boat)

    moments_oil = cv2.moments(thresh_oil, 1)
    dM01_oil = moments_oil['m01']
    dM10_oil = moments_oil['m10']
    dArea_oil = moments_oil['m00']

    moments_boat = cv2.moments(thresh_boat, 1)
    dM01_boat = moments_boat['m01']
    dM10_boat = moments_boat['m10']
    dArea_boat = moments_boat['m00']

    if dArea_oil > 100:
        x_oil = int(dM10_oil / dArea_oil)
        y_oil = int(dM01_oil / dArea_oil)
        cv2.circle(img, (x_oil, y_oil), 10, (0, 255, 0), -1)
        zone = detect_zone(x_oil, y_oil, img)
        cv2.putText(img, str(x_oil) + ' ' + str(y_oil), (x_oil + 20, y_oil + 20), cv2.FONT_HERSHEY_SIMPLEX, 1,
                    color_yellow, 2)
        draw_zones(img)

    if dArea_boat > 100:
        x_boat = int(dM10_boat / dArea_boat)
        y_boat = int(dM01_boat / dArea_boat)
        cv2.circle(img, (x_boat, y_boat), 10, (255, 0, 0), -1)
        cv2.putText(img, str(x_boat) + ' ' + str(y_boat), (x_boat + 20, y_boat + 20), cv2.FONT_HERSHEY_SIMPLEX, 1,
                    color_yellow, 2)

    if dArea_boat > 100 and dArea_oil > 100:
        if abs(x_oil - x_boat) <= 9:
            dist = abs(x_oil - x_boat) * 1000
        elif abs(x_oil - x_boat) >= 10 and abs(x_oil - x_boat) <= 99:
            dist = abs(x_oil - x_boat) * 100
        my_client.publish(topik, str(zone) + " " + str(dist))

    if i <= 1:
        my_client.publish(topik, str(zone) + " " + str(dist))

    elif i > 1:
        print(':')




    cv2.imshow('result', img)

    ch = cv2.waitKey(5)
    if ch == 27:
        break
cap.release()
cv2.destroyAllWindows()