#include <ESP8266WiFi.h>   //подключение билиотеки
#include <PubSubClient.h>  //подключение библитеки для работы протокола MQTT
#include <Servo.h>
#define IN1 D5  //brown
#define IN2 D4  //blue
#define IN3 D2  //white
#define IN4 D1  //purple
Servo m_r;
Servo m_l;
int pin_m_r = D5;
int pin_m_l = D6;
int speed_r = 0;
int speed_l = 0;

int g;
WiFiClient esp;
PubSubClient board(esp);  //создание объекта боард
char payload_message_turn[4];
char payload_message_forward[4];
int flag = 0;
int l;
int p;

void move(int power_l, int power_r, int mlsec) { 
  m_l.writeMicroseconds(speed_l);
  delay(mlsec);
}

void stop() {
  move(0, 0, 2000);
}

// void turn_right(int p) {
//   move(60, -60, p * 11.1);
//   stop();
// }
void forward_x(int px) {
  move(-40, 60, px);
  stop();
}
void right(int g) {
  move(-60, -60, g * 5.6);
  stop();
}
void left(int p) {
  move(-60, 60, p * 5.6);
  stop();
}

void receive_message(char* topic, byte* payload, int length) {
  int k = 0;
  int j = 0;
  int flag2 = 0;
  for (int i = 0; i < length; i++) {
    if (payload[i] == ' ') {
      flag2 = 1;
    }
    if (payload[i] != ' ' && flag2 == 0) {
     payload_message_turn[k] = payload[i];
      k++;
    }
    if (payload[i] != ' ' && flag2 == 1) {
      payload_message_forward[j] = payload[i];
      j++;
    }
  }
  g = atoi(payload_message_turn);
  if (g == 1){
    right(460);
  }
  else if (g == 2){
    right(90);
  }
  else if (g == 3){
    right(155);
  }
  else if (g == 4){
    right(345);
  }
  payload_message_turn[k] = '\0';
  payload_message_forward[j] = '\0';
  Serial.println(payload_message_turn);
  Serial.println(payload_message_forward);
  l = atoi(payload_message_forward);
  // p = atoi(payload_message);
  // 
  // forward_x(l);
  // right(g);
  forward_x(l);
  board.publish("user_57fda11f/aqua1", "stop");  //и отправим на брокер сообщение о подключении
}

void setup() {
  //WiFi.begin("RoboStation", "sunschool");   // подключение платы к WIFI
  WiFi.begin("Galaxy Note20", "Parolili");        // подключение платы к WIFI
  pinMode(LED_BUILTIN, OUTPUT);             //настройка пина
  board.setServer("srv1.clusterfly.ru", 9124);  //установка адреса и порта
  board.setCallback(receive_message);       //вызов функции при принятии сообщения
  Serial.begin(115200);
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, LOW);
  digitalWrite(IN3, LOW);
  digitalWrite(IN4, LOW);
  m_r.attach(pin_m_r);
  m_l.attach(pin_m_l);
  m_r.writeMicroseconds(1500);
  m_l.writeMicroseconds(1500);
  delay(5000);
}

void loop() {
  if (WiFi.status() == WL_CONNECTED && board.connected() != 0)  //если плата подключена к WIFI и к брокеру
  {
    digitalWrite(LED_BUILTIN, LOW);  // то включаем светодиод
    if (flag == 0) {
      board.publish("user_57fda11f/aqua1", "ready");  //и отправим на брокер сообщение о подключении
      flag = 1;
    }
    // Serial.println("good");
  } else if (WiFi.status() == WL_CONNECTED && board.connected() == 0)  //если плата подключена к WIFI, но не к брокеру
  {
    board.connect("esp_we55f", "user_57fda11f", "eewcBWaoNskSm");  // то подключаемся к брокеру
    board.subscribe(" ");                             //подклюимся к топику для принятия сообщения
    digitalWrite(LED_BUILTIN, LOW);                      // и включаем светодиод
    delay(1000);
    digitalWrite(LED_BUILTIN, HIGH);
    delay(1000);
  } else {
    digitalWrite(LED_BUILTIN, HIGH);  // выключаем свтеодиод, если не подключены к WIFI
    Serial.println("no");
  }
  board.loop();
}